=begin
(c) TIG 2011
  Exportcpoints2tsv.new
in the Ruby Console.
Exports all Cpoints is a Selection to a X,Y,Z 'TSV' file.
The sep="\t", the decsep=',' and ext='tsv'.
Change decsep='.' IF you want 1.234 rather than 1,234 or run with arguments 
as shown below...
Model Units are used and get exported to the TSV in say meters as 1,234 - 
it always forces 3dp even when not needed - e.g. 0,100
Check that your locale Excel uses ','/'.' matching your output.
You can affect output by adding an argument to the command line, e.g.
It returns XYZ format by default BUT if you type
  Exportcpoints2tsv.new 1
it will then use YXZ format.
To change from ',' to '.' as the decimal separator, type 
  Exportcpoints2tsv.new 2
To change from ',' to '.' as the decimal separator AND use YXZ, type
  Exportcpoints2tsv.new 3
###
1.0 20110914 First issue.
1.1 20110915 Forces 3dp always, command-line argument to change format.
=end
require 'sketchup.rb'
###
class Exportcpoints2tsv
def initialize(xyz=nil)
    sep="\t" ### <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ext="tsv" ### <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    if xyz==2 or xyz==3
      decsep='.'
    else
      decsep=',' ### <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    end#if
    model=Sketchup.active_model
    ss=model.selection
    cpoints=[]
    ss.each{|e|cpoints << e if e.class==Sketchup::ConstructionPoint}
    if not cpoints
      UI.messagebox("No Cpoints were Selected.\nExiting.")
	  return nil
    end#if
    units=1.0
    units=1.0 if model.options["UnitsOptions"]["LengthUnit"]==0
    units=1/12.0 if model.options["UnitsOptions"]["LengthUnit"]==1
    units=25.4 if model.options["UnitsOptions"]["LengthUnit"]==2
    units=2.54 if model.options["UnitsOptions"]["LengthUnit"]==3
    units=0.0254 if model.options["UnitsOptions"]["LengthUnit"]==4
    pts=[]
    cpoints.each{|p|
      x=sprintf("%.3f", p.position.x.to_f*units).tr!('.',decsep)
      y=sprintf("%.3f", p.position.y.to_f*units).tr!('.',decsep)
      z=sprintf("%.3f", p.position.z.to_f*units).tr!('.',decsep)
       if xyz==1 or xyz==3
        pts << y+sep+x+sep+z
      else
        pts << x+sep+y+sep+z
      end#if
    }
    path=model.path
    if not path or path==""
      path=Dir.pwd
      title="Untitled"
    else
      path=File.dirname(path)
      title=model.title
    end#if
    ofile=File.join(path,title+'_cpoints.'+ext).tr("\\","/")
    begin
      file=File.new(ofile,"w")
    rescue### trap if open
      UI.messagebox("Cpoints File:\n\n  "+ofile+"\n\nCannot be written - it's probably already open.\nClose it and try making it again...\n\nExiting...")
	  return nil
    end
    pts.each{|pt|file.puts(pt)}
    file.close
    puts (pts.length.to_s)+" cpoints written to\n"+ofile
    if xyz==1 or xyz==3
      puts "in YXZ format."
    else
      puts "in XYZ format."
    end#if
    puts
    puts pts
    puts "\nDONE."
    begin
      UI.openURL("file:/"+ofile)
    rescue
    end
end#def
end#class
###


